objectdef pipslot
{
	variable int X
	variable int Y
	variable int Width
	variable int Height

	variable string SessionName
	variable bool IsTaken=FALSE

	method Initialize(int x, int y, int width, int height)
	{
		X:Set[${x}]
		Y:Set[${y}]
		Width:Set[${width}]
		Height:Set[${height}]
	}

	member ToText()
	{
		return ${X},${Y},${Width},${Height}
	}

	method ClearSession()
	{
		IsTaken:Set[FALSE]
		SessionName:Set[""]
	}

	method Assign(string name)
	{
		SessionName:Set["${name}"]
		IsTaken:Set[TRUE]
	}

	member Position()
	{
		return ${X},${Y}
	}

	member Size()
	{
		return ${Width}x${Height}
	}
}

objectdef pipsqueak
{
	variable index:pipslot Slots

	variable string Mode="Session1Fill"
	variable int LastActive=1

	method Initialize()
	{
		Slots:Resize[10]
		LavishScript:RegisterEvent[OnSessionRenamed]

		Event[OnSessionRenamed]:AttachAtom[This:OnSessionRenamed]
	}

	member:int FindSession(string name)
	{
		return ${name.Right[-2]}
	}

	method Session1Fill(int ActiveSession)
	{
		/* move LastActive back to that slot # */
		if ${LastActive}!=1
		{
			relay is${LastActive} snapset -pos ${This.Slots[${LastActive}].Position} -size ${This.Slots[${LastActive}].Size} -deactivate
			This.Slots[${LastActive}]:Assign[is${LastActive}]
		}

		if ${ActiveSession}!=1
		{
			/* move session 1 to ActiveSession slot # */
			relay is1 snapset -pos ${This.Slots[${ActiveSession}].Position} -size ${This.Slots[${ActiveSession}].Size} -deactivate
			This.Slots[${ActiveSession}]:Assign[is1]
			
		}
	}

	method OnSessionRenamed(string oldname, string newname)
	{
		if ${newname.Left[2].Equal[is]} && ${This.Slots[1](exists)}
		{
			variable int useslot
			useslot:Set[${newname.Right[-2]}]
			if ${useslot}==1
				useslot:Set[2]

			relay ${newname} "windowpos -viewable ${This.Slots[1].Position};windowsize -viewable ${This.Slots[1].Size};run windowsnapper -pipsqueak -pos ${This.Slots[${useslot}].Position} -size ${This.Slots[${useslot}].Size}"

		}
	}

	method OnSessionActivated(string name)
	{
		variable int SessionID
		SessionID:Set[${This.FindSession["${name}"]}]
		if !${SessionID}
			return

		if ${SessionID}==${LastActive}
			return	

		switch ${Mode}
		{
		case Session1Fill
			This:Session1Fill[${SessionID}]
			break
		}
		LastActive:Set[${SessionID}]
	}
	
}

variable pipsqueak PiPSqueak

atom(global) pipsqueak(... Params)
{
	/* Process parameters */
	variable int p=1
	variable int nSlot
	for (${p}<=${Params.Size} ; p:Inc)
	{
		/* Switch does a string comparison, so parameter processing is easy */
		switch ${Params[${p}]}
		{
		case -activate
			/* we got the -pos switch, so if there's another parameter, set Snapper.SnapPos to the new value */
			p:Inc
			if ${p}<=${Params.Size}
				PiPSqueak:OnSessionActivated["${Params[${p}]}"]
			break
		case -slot
			p:Inc
			if ${p}>${Params.Size}
				break
			nSlot:Set["${Params[${p}]}"]
			p:Inc
			if ${nSlot}<1 || ${p}>${Params.Size}
				break
			PiPSqueak.Slots:Set[${nSlot},${Params[${p}]}]
			echo Slot ${nSlot} is now ${PiPSqueak.Slots.Get[${nSlot}]}	
			break
		}
	}

	
}

function main()
{
	relay all "squelch run windowsnapper -pipsqueak;snapset -pipsqueak"
	while 1
		waitframe	
}


